<%@ Page Language="C#" %>
<%@ Import Namespace="Microsoft.SharePoint" %>
<%@ Import Namespace="Microsoft.SharePoint.Workflow" %>

<script runat="server">

  // Version History
  // 1.0.0  8.04.2011 initial release
  // 1.0.1 23.05.2011 PDF support added
  // 1.0.2 24.01.2013 YouTube videos now shown in IFRAME for SP2010
  // 1.0.3  8.02.2016 Silverlight player added
  // 1.0.4 14.10.2016 RTMP fixed
  // 1.0.5  9. 3.2017 useHTML5 parameter added

  string lit = "";
  
    protected override void OnLoad(EventArgs e)
    {
      bool trace = HttpContext.Current.Request.QueryString["aetrace"] == "9999";
      string mypath = HttpContext.Current.Server.MapPath(@"~\_layouts"); //c:\Program Files\Common Files\Microsoft Shared\Web Server Extensions\12\template\layouts
      bool SP2010 = mypath.Contains("\\14\\") || mypath.Contains("\\15\\");
      if (trace) lit += "<br>SP2010=" + SP2010;

      bool _UseQuickTimePlayer = HttpContext.Current.Request.QueryString["useQuickTime"] == "1";
      bool _UseFlvPlayer = HttpContext.Current.Request.QueryString["useFlv"] == "1";
      bool _UseSilverlightPlayer = HttpContext.Current.Request.QueryString["useSilverlight"] == "1";
      bool _UseMediaPlayer = HttpContext.Current.Request.QueryString["useMediaPayer"] == "1";
      bool _UseFlashPlayer = HttpContext.Current.Request.QueryString["useFlash"] == "1";
      bool _UseHtml5 = HttpContext.Current.Request.QueryString["useHtml5"] == "1";
      string movieURL = HttpContext.Current.Request.QueryString["movie"];
      if (trace) lit += "<br>Movie=" + movieURL;

      string autoStart = "true";
      bool _AutoStart = HttpContext.Current.Request.QueryString["autoStart"] != "0";
      if (!_AutoStart) autoStart = "false";
      
      string playerWidth = "100%";
      string playerWidPx = "100%";
      string playerHeight = "100%";
      bool _LoopVideo = HttpContext.Current.Request.QueryString["loopVideo"] == "1";

      string https = "";
      if (HttpContext.Current.Request.IsSecureConnection) https = "s";
      bool useSSL = (https != "" && ConfigurationSettings.AppSettings["AEMP_SSL"] != "0");

      if (string.IsNullOrEmpty(movieURL))
	  {
		lit = "<p style='font:12pt Segoe UI'>Please select a video!</p>";
	  }
      else if (movieURL.IndexOf("www.youtube.com") > 0 || movieURL.IndexOf("youtu.be/") > 0)
      {
        string fixedURL = movieURL.Replace("/watch?v=", "/v/"); // http://www.youtube.com/watch?v=25DXcFg1TFo
		fixedURL = fixedURL.Replace("//youtu.be/", "//www.youtube.com/embed/"); //http://youtu.be/bGuezZsGUiA

        if (autoStart == "true")
		{
			if (fixedURL.Contains("?"))
				fixedURL += "&autoplay=1";
			else
				fixedURL += "?autoplay=1";
		}

        if (trace) lit += "<br>fixedURL=" + fixedURL;
        lit += "<p style='margin-top:3px; line-height:3px; margin-bottom:0px'></p>";
        lit += "<div style='display:flex;width:100%;height:98%;background-color:black'>";
		
        if (SP2010)
        {
          lit += "<iframe id='pid' width='" + playerWidth + "' height='" + playerHeight + "' src='" + fixedURL + "' frameborder='0' style='border:1px solid gray' allowtransparency='true' allowfullscreen></iframe>";
        }
        else
        {
          lit += "<object ID=\"pid\" width=\"" + playerWidth + "\" height=\"" + playerHeight + "\">";
          lit += "<param name=\"movie\" value=\"" + fixedURL + "&hl=en&fs=1\"></param>";
          lit += "<param name=\"allowFullScreen\" value=\"true\"></param>";
          lit += "<embed name=\"pid\" src=\"" + fixedURL + "&hl=en&fs=1\" type=\"application/x-shockwave-flash\" wmode=\"transparent\" allowscriptaccess=\"always\" width=\"" + playerWidth + "\" height=\"" + playerHeight + "\" allowfullscreen=\"true\"></embed>";
          lit += "</object>";
        }
        lit += "</div>";
      }
      else
      {
        string ext = "";
        ext = movieURL.ToLower().Substring(movieURL.Length - 4, 4);
        if (trace) lit += "<br>ext=" + ext;
        if (useSSL) movieURL = movieURL.Replace("http://", "https://");

        string ua = HttpContext.Current.Request.UserAgent.ToLower();
        if (trace) lit += "<br>ua=" + ua;
		string options = "";
		if (autoStart == "true") options = " autoplay";
		string controlsList = HttpContext.Current.Request.QueryString["controlslist"];
		if (!string.IsNullOrEmpty(controlsList)) controlsList = " controlsList='" + controlsList + "'";

        if (_UseSilverlightPlayer)
		{
          lit += "<OBJECT ID=\"silver\" type=\"application/x-silverlight-2\" data=\"data:application/x-silverlight-2,\" width=" + playerWidth + " height=" + playerHeight + ">";
          lit += "<PARAM NAME=source VALUE=\"/_layouts/clientbin/mediaplayer.xap\">";
          lit += "<PARAM NAME=enableHtmlAccess VALUE=true>";
          lit += "<PARAM NAME=windowless VALUE=true>";
          string silverParam = movieURL;
          if (autoStart == "true") silverParam += ",autoPlay=true";
          if (_LoopVideo) silverParam += ",loop=true";
          lit += "<PARAM NAME=initParams value='mediaSource=" + silverParam + "' />";
          lit += "</OBJECT>";
		}
		else if (_UseHtml5)
        {
            if (trace) lit += "<br>using HTML5 VIDEO tag";
            lit += "<video src='" + movieURL + "' width='" + playerWidth + "' height='" + playerHeight + "' controls" + options + controlsList + "></video>";
        }
		else if (!_UseFlvPlayer && !_UseMediaPlayer && (ext == ".mov" || ext == ".mp4" || ext == ".m4v" || _UseQuickTimePlayer))
        {
          if (ua.Contains("iphone") || ua.Contains("ipod") || ua.Contains("ipad") || ua.Contains("chrome"))
          {
            if (trace) lit += "<br>using HTML5 VIDEO tag";
            lit += "<video src='" + movieURL + "' width='" + playerWidth + "' height='" + playerHeight + "' controls" + options + "></video>";
          }
          else
          {
            if (trace) lit += "<br>using Quicktime Plugin";
            lit += "<OBJECT ID=\"pid\" width=" + playerWidth + " height=" + playerHeight + " classid=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\" codebase=\"http" + https + "://www.apple.com/qtactivex/qtplugin.cab\" align=\"middle\">";
            lit += "<PARAM name=\"src\" value=\"" + movieURL + "\">";
            lit += "<PARAM name=\"autoplay\" value=\"" + autoStart + "\">";
            lit += "<PARAM NAME=\"controller\" value=\"true\">";
            lit += "<PARAM NAME=\"type\" value=\"video/quicktime\">";
            lit += "<PARAM NAME=\"scale\" value=\"aspect\">";
            lit += "<PARAM NAME=\"enablejavascript\" value=\"true\">";
            lit += "<EMBED type=\"video/quicktime\" enablejavascript=\"true\" scale=\"aspect\" pluginspage=\"http" + https + "://www.apple.com/quicktime/download/\" src=\"" + movieURL + "\" name=\"pid\" width=" + playerWidth + " height=" + playerHeight + " autoplay=\"false\" controller=\"true\"></EMBED>";
            lit += "</OBJECT>";
          }
        }
        else if (ext == ".pdf")
        {
            lit += "<embed src=\"" + movieURL + "#navpanes=0\" width=" + playerWidth + " height=" + playerHeight + ">";
        }
        else if (ext == ".swf" && _UseFlashPlayer)
        {
          lit += "<OBJECT classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" codebase=\"http" + https + "://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0\" " +
                  "width=" + playerWidth + " height=" + playerHeight + ">";
          lit += "<PARAM NAME=movie VALUE=\"" + movieURL + "\"> ";
          lit += "<PARAM NAME=wmode VALUE=\"transparent\">";
          lit += "<PARAM NAME=quality VALUE=high>";
          lit += "<PARAM NAME=play VALUE=" + autoStart + ">";
          lit += "<PARAM NAME=menu VALUE=true>";
          lit += "<EMBED src=\"" + movieURL + "\" quality=high wmode=\"transparent\" width=\"" + playerWidth + "\" height=\"" + playerHeight +
                  "\" TYPE=\"application/x-shockwave-flash\" PLUGINSPAGE=\"http" + https + "://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash\"></EMBED>";
          lit += "</OBJECT>";
        }
        else if (ext == ".flv" || ext == ".f4v" || ext == ".swf" || _UseFlvPlayer)
        {
          string flvPlayer = "MediaPlayer.swf";
          if (autoStart == "true") movieURL += "&autostart=true";
          string flv = movieURL;
          if (flv.StartsWith("rtmp://"))
          {
            flv = "streamer=" + flv;
			string file = HttpContext.Current.Request.QueryString["file"];
			if (!string.IsNullOrEmpty(file)) flv += "&file=" + file;
            flv += "&type=rtmp";
          }
          else
          {
            flv = "file=" + flv;
          }
          if (_LoopVideo) flv += "&repeat=always";
          lit += "<OBJECT ID=\"pid\" width=" + playerWidth + " height=" + playerHeight + " classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" codebase=\"http" + https + "://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0\">";
          lit += "<PARAM name=\"flashvars\" value=\"" + flv + "\" />";
          lit += "<PARAM name=\"movie\" value=\"" + flvPlayer + "\" />";
          lit += "<PARAM name=\"allowfullscreen\" value=\"false\" />";
          lit += "<PARAM NAME=\"wmode\" VALUE=\"transparent\">";
          lit += "<EMBED name=\"pid\" id=\"pid\" src=\"" + flvPlayer + "\" width=" + playerWidth + " height=" + playerHeight + " wmode=\"transparent\" allowfullscreen=\"false\" type=\"application/x-shockwave-flash\" pluginspage=\"http" + https + "://www.macromedia.com/go/getflashplayer\" flashvars=\"" + flv + "\" />";
          lit += "</OBJECT>";
        }
		else if (movieURL.ToLower().Contains("vimeo.com/"))  //http://vimeo.com/channels/staffpicks/64995776
		{
			string vimeoID = "";
			string display = "";
			int p = movieURL.LastIndexOf("/");
			vimeoID = "http" + https + "://player.vimeo.com/video/" + movieURL.Substring(p + 1);
			lit += "<iframe src='" + vimeoID + "' width='" + playerWidth + "' height='" + playerHeight + "' frameborder='0' webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>";
		}
        else if (movieURL.ToLower().Contains("kaltura.com"))
        {
          lit += "<object name=\"kaltura_player_1299145316\" id=\"Object1\" type=\"application/x-shockwave-flash\" allowScriptAccess=\"always\" allowNetworking=\"all\" allowFullScreen=\"true\" height=" + playerHeight + " width=" + playerWidth + ">";
          lit += "<param name=\"allowScriptAccess\" value=\"always\" />";
          lit += "<param name=\"allowNetworking\" value=\"all\" />";
          lit += "<param name=\"allowFullScreen\" value=\"true\" />";
          lit += "<param name=\"bgcolor\" value=\"#000000\" />";
          lit += "<param name=\"movie\" value=\"" + movieURL + "\">";
          lit += "<param name=\"flashVars\" value=\"\"/>";
          lit += "</OBJECT>";
        }
        else //Windows Media Player
        {
          lit += "<OBJECT ID=\"pid\" width=" + playerWidth + " height=" + playerHeight + " classid=\"CLSID:6BF52A52-394A-11d3-B153-00C04F79FAA6\" codebase=\"http" + https + "://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=6,0,02,902\" standby=\"Loading Microsoft Windows Media Player components...\" type=\"application/x-oleobject\" align=\"middle\">";
          lit += "<PARAM name=\"URL\" value=\"" + movieURL + "\">";
          lit += "<PARAM name=\"AutoStart\" value=\"" + autoStart + "\">";
          lit += "<PARAM name=\"ShowStatusBar\" value=\"True\">";
          lit += "<PARAM NAME=\"showControls\" value=\"true\">";
          lit += "<PARAM name=\"windowlessVideo\" value=\"true\">";
          lit += "<PARAM NAME=\"DisplayBackColor\" value=\"0\">";
          if (_LoopVideo)
          {
            lit += "<PARAM NAME=\"PlayCount\" value=\"9999\">";
          }
          lit += "<EMBED type=\"application/x-mplayer2\" pluginspage=\"http" + https + "://www.microsoft.com/Windows/MediaPlayer/\" SRC=\"" + movieURL + "\" name=\"pid\" width=" + playerWidth + " height=" + playerHeight + " AutoStart=true></EMBED>";
          lit += "</OBJECT>";
        }
      }
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head><title>Video Viewer</title></head>
<body style="margin:0px;padding:0px;font:8pt Consolas" onblur="this.focus()">
   <%=lit%>
</body>
</html>
